import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.OneToOne;
import javax.persistence.OneToMany;
import java.util.*;

/*
 * Department
 */

@Entity
@Table(name="JPA_DEPT")
public class Department implements java.io.Serializable {

    // Instance variables
    private int  id;
    private String  name;
    private Set<Employee> employees;
    private Set<EmployeeDel1> employeeDel1s;
    private Set<EmployeeDel2> employeeDel2s;

    public Department() {
    }

    public Department(int id, String name) {
        this.id = id;
        this.name = name;
    }

    // ===========================================================
    // getters and setters for the state fields

    @Id
    @Column(name="ID")
    public int getId() {
        return id;
    }
    public void setId(int id) {
        this.id = id;
    }

    @Column(name="NAME")
    public String getName() {
        return name;
    }
    public void setName(String name) {
        this.name = name;
    }

    // ===========================================================
    // getters and setters for the association fields
    @OneToMany(cascade=CascadeType.ALL, mappedBy="department")   
    public Set<Employee> getEmployees() {
        return employees;
    }
    public void setEmployees(Set<Employee> employees) {
        this.employees = employees;
    }
    public void addEmployee(Employee employee) {
        this.employees.add(employee);
    }

    @OneToMany(cascade=CascadeType.ALL, mappedBy="department")   
    public Set<EmployeeDel1> getEmployeeDel1s() {
        return employeeDel1s;
    }
    public void setEmployeeDel1s(Set<EmployeeDel1> employeeDel1s) {
        this.employeeDel1s = employeeDel1s;
    }
    public void addEmployeeDel1(EmployeeDel1 employeeDel1) {
        this.employeeDel1s.add(employeeDel1);
    }

    @OneToMany(cascade=CascadeType.ALL, mappedBy="department")   
    public Set<EmployeeDel2> getEmployeeDel2s() {
        return employeeDel2s;
    }
    public void setEmployeeDel2s(Set<EmployeeDel2> employeeDel2s) {
        this.employeeDel2s = employeeDel2s;
    }
    public void addEmployeeDel2(EmployeeDel2 employeeDel2) {
        this.employeeDel2s.add(employeeDel2);
    }

    public String toString() {
        return "Department id=" + getId() + ", Department Name=" + getName();
    }

}

