import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.CascadeType;
import javax.persistence.FetchType;
import javax.persistence.Table;
import javax.persistence.Column;
import javax.persistence.JoinColumn;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;


/*
 * Employee
 */

@Entity
@Table(name="JPA_EMP")
public class Employee implements java.io.Serializable {

    private int	     	     id;
    private String	     firstName;
    private String	     lastName;
    private String	     ext;
    private Department       department;

    public Employee() {
    }

    public Employee(int id, String firstName, String lastName)
    {
        	this.id = id;
        	this.firstName = firstName;
        	this.lastName = lastName;
    }

    public Employee(int id, String firstName, String lastName, 
		    String ext, Department department) {
        	this.id = id;
        	this.firstName = firstName;
        	this.lastName = lastName;
        	this.ext = ext;
        	this.department = department;
    }

   // ===========================================================
   // getters and setters for the state fields
    @Id
    @Column(name="ID")
    public int getId() {
        return id;
    }
    public void setId(int id) {
        this.id = id;
    }

    @Column(name="FNAME", length=25)
    public String getFirstName() {
        return firstName;
    }
    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    @Column(name="LNAME", length=25)
    public String getLastName() {
        return lastName;
    }
    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    @Column(name="EXT", length=10)
    public String getExt() {
        return ext;
    }
    public void setExt(String ext) {
        this.ext = ext;
    }


    // ===========================================================
    // getters and setters for the association fields
    @ManyToOne
    @JoinColumn(name="DEPT_ID")
    public Department getDepartment() {
        return department;
    }
    public void setDepartment(Department department) {
        this.department = department;
    }

    public String toString() {
        return "Employee id=" + getId() 
                + ", firstName=" + getFirstName() 
                + ", lastName=" + getLastName() 
                + ", ext=" + getExt() 
                + ", department=" + getDepartment();
    }


}

