import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.CascadeType;
import javax.persistence.FetchType;
import javax.persistence.Table;
import javax.persistence.Column;
import javax.persistence.JoinColumn;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.NamedNativeQuery;

/*
 * EmployeeDel1
 */
@Entity
@Table(name="\"JPA_EMP_DEL\"")
@NamedNativeQuery(
    name="findAllEmployeeDel1s", 
    query="select * from \"JPA_EMP_DEL\"",
    resultClass=EmployeeDel1.class
)
public class EmployeeDel1 implements java.io.Serializable {

    private int	     	     id;
    private String	     firstName;
    private String	     lastName;
    private String	     extD1;
    private Department       department;

    public EmployeeDel1() {
    }


    public EmployeeDel1(int id, String firstName, String lastName)
    {
        	this.id = id;
        	this.firstName = firstName;
        	this.lastName = lastName;
    }

    public EmployeeDel1(int id, String firstName, String lastName, 
		    String extD1, Department department) {
        	this.id = id;
        	this.firstName = firstName;
        	this.lastName = lastName;
        	this.extD1 = extD1;
        	this.department = department;
    }

    // ===========================================================
    // getters and setters for the state fields
    @Id
    @Column(name="ID")
    public int getId() {
        return id;
    }
    public void setId(int id) {
        this.id = id;
    }

    @Column(name="FNAME", length=20)
    public String getFirstName() {
        return firstName;
    }
    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }


    @Column(name="LNAME", length=20)
    public String getLastName() {
        return lastName;
    }
    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    @Column(name="\"JPA_EXT_DEL\"", length=30)
    public String getExtD1() {
        return extD1;
    }
    public void setExtD1(String extD1) {
        this.extD1 = extD1;
    }


    // ===========================================================
    // getters and setters for the association fields
    @ManyToOne
    @JoinColumn(name="DEPT_ID")
    public Department getDepartment() {
        return department;
    }
    public void setDepartment(Department department) {
        this.department = department;
    }

    public String toString() {
        return "Employee id=" + getId() 
                + ", firstName=" + getFirstName() 
                + ", lastName=" + getLastName() 
                + ", extD1=" + getExtD1() 
                + ", department=" + getDepartment();
    }


}

