import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.CascadeType;
import javax.persistence.FetchType;
import javax.persistence.Table;
import javax.persistence.Column;
import javax.persistence.JoinColumn;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.NamedNativeQuery;

/*
 * EmployeeDel2
 */

@Entity
@Table(name="\"Jpa_Emp_Del\"")
@NamedNativeQuery(
    name="findAllEmployeeDel2s", 
    query="select * from \"Jpa_Emp_Del\"",
    resultClass=EmployeeDel2.class
)
public class EmployeeDel2 implements java.io.Serializable {

    private int	     	     id;
    private String	     firstName;
    private String	     lastName;
    private String	     extD2;
    private Department       department;

    public EmployeeDel2() {
    }

    public EmployeeDel2(int id, String firstName, String lastName)
    {
        	this.id = id;
        	this.firstName = firstName;
        	this.lastName = lastName;
    }

    public EmployeeDel2(int id, String firstName, String lastName, 
		    String extD2, Department department) {
        	this.id = id;
        	this.firstName = firstName;
        	this.lastName = lastName;
        	this.extD2 = extD2;
        	this.department = department;
    }

    // ===========================================================
    // getters and setters for the state fields
    @Id
    @Column(name="ID")
    public int getId() {
        return id;
    }
    public void setId(int id) {
        this.id = id;
    }

    @Column(name="FNAME", length=15)
    public String getFirstName() {
        return firstName;
    }
    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }


    @Column(name="LNAME", length=15)
    public String getLastName() {
        return lastName;
    }
    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    @Column(name="\"Jpa_Ext_Del\"", length=30)
    public String getExtD2() {
        return extD2;
    }
    public void setExtD2(String extD2) {
        this.extD2 = extD2;
    }


    // ===========================================================
    // getters and setters for the association fields
    @ManyToOne
    @JoinColumn(name="DEPT_ID")
    public Department getDepartment() {
        return department;
    }
    public void setDepartment(Department department) {
        this.department = department;
    }

    public String toString() {
        return "Employee id=" + getId() 
                + ", firstName=" + getFirstName() 
                + ", lastName=" + getLastName() 
                + ", extD2=" + getExtD2() 
                + ", department=" + getDepartment();
    }

}


